; Loader 16F876 , eeprom  24C32 e superiori 
; Beta release
;---------------------------------------------------------------------------

	LIST    P=16F876

;---------------------------------------------------------------------------
; DEFINIZIONI 16F876  
;---------------------------------------------------------------------------

INDIR   equ 000H
PCL     equ 002H
PCLATH  equ 00AH
STATUS  equ 003H
C       equ 000H
Z       equ 002H
RP0     equ 005H
RP1     equ 006H
IRP     equ 007H
FSR     equ 004H
PORTA   equ 005H
PORTB   equ 006H
ADCON0  equ 01FH
OPTIONR equ	001H		      ; pagina 1
TRISA   equ	005H		      ; pagina 1
TRISB   equ	006H           	; pagina 1 
TRISC   equ	007H           	; pagina 1
ADCON1  equ	01FH           	; pagina 1
EEDATA  equ	00CH		      ; pagina 2
EEADR   equ	00DH		      ; pagina 2
EEDATAH equ 00EH              ; pagina 2
EEADRH  equ 00FH              ; pagina 2 
EECON1  equ	00CH		      ; pagina 3
EEPGD   equ 007H
WR      equ 001H
RD      equ 000H
WREN    equ 002H
EECON2  equ	00DH	      	; pagina 3
W       equ 000H
F       equ 001H                


;---------------------------------------------------------------------------
; REMAPPING ISTRUZIONI
;---------------------------------------------------------------------------

#DEFINE skipz   btfss STATUS,Z
#DEFINE skipnz  btfsc STATUS,Z
#DEFINE skipc   btfss STATUS,C
#DEFINE skipnc  btfsc STATUS,C
#DEFINE carrybit      STATUS,C
#DEFINE irpbit        STATUS,IRP  
;---------------------------------------------------------------------------
; DEFINIZIONE BIT I/O PORTA B
;---------------------------------------------------------------------------

rb4     equ 04H                 ; pin 10
rb5     equ 05H                 ; pin 11
rb7     equ 07H                 ; pin 13
iocam   equ rb7                 ; i/o CAM
sda     equ rb4                 ; serial data eeprom esterna
scl     equ rb5                 ; serial clock eeprom esterna

;---------------------------------------------------------------------------
; STRUTTURA RAM UTENTE 16F876
;
; Banco 0   96 byte      da 020H a 07FH     
; Banco 1   80 byte      da 0A0H a 0EFH
; Banco 2   80 byte      da 120H a 16FH
; Banco 3   80 byte      da 1A0H a 1EFH
;---------------------------------------------------------------------------

;Banco 0
	CBLOCK  020H
		cla             ;class byte
		inst            ;instruction byte
		eeindirh        ;indirizzo basso eeprom
		eeindirl        ;050 indirizzo alto eeprom
		p3len           ;lunghezza o P3 
		msglen          ;lunghezza stringa
		checksum        ;checksum
		bytecnt         ;contatore generico
		rxtxcnt         ;contatore generico
		eepdata         ;byte eeprom
		txrx            ;variabile colloquio CAM
		txbuf           ;variabile colloquio CAM
		rxtxdelay       ;ritardo
		check           ;0      1 = tx da eeprom diminuisce init delay
		                ;1      1 = tx da eeprom elimina ritardo finale
                            ;2     	......................................
                            ;3      ......................................
                            ;4      ......................................
                            ;5      1 = scrittura in eeprom
                            ;6      ......................................
                            ;7      ......................................
		rxbuffer        ;buffer di ricezione
	ENDC

;---------------------------------------------------------------------------
; Inizio programma
;---------------------------------------------------------------------------
		ORG     0x0000
start
	GOTO    main
	NOP
	NOP
	NOP
	NOP


;---------------------------------------------------------------------------
; MAIN
;---------------------------------------------------------------------------
main
	CLRF    check
	CALL    delay
	MOVLW   0FFH            ;tutti i pin PORTB come ingressi
	MOVWF   PORTB           ;mette ffH anche nel buffer della PORTB
	BSF     STATUS,RP0      ;pagina 1
	MOVWF   TRISB           ;configura la porta B
	MOVLW   07FH            ;7Fh in W e lo mette nel registro OPTION
	MOVWF   OPTIONR         ;pullup port B on,
				      ;prescaler al wdt e division ratio di 1:128
				      ;non hanno significato per questo programma
	BCF     STATUS,RP0      ;pagina 0
	BSF     PORTB,iocam     ;siccome sono configurati come ingressi
				      ;lo stato dell'uscita non viene modificato
				      ;in questo modo quando faccio diventare
				      ;iocam uscita il pin andra' alto

;---------------------------------------------------------------------------
; Invio_atr
; 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 90 00
;---------------------------------------------------------------------------
ATR
	MOVLW  001H
	CALL   sendcam
	MOVLW  002H
	CALL   sendcam
	MOVLW  003H
	CALL   sendcam
	MOVLW  004H
	CALL   sendcam
	MOVLW  005H
	CALL   sendcam
	MOVLW  006H
	CALL   sendcam
	MOVLW  007H
	CALL   sendcam
	MOVLW  008H
	CALL   sendcam
	MOVLW  009H
	CALL   sendcam
	MOVLW  00AH
	CALL   sendcam
	MOVLW  00BH
	CALL   sendcam
	MOVLW  00CH
	CALL   sendcam
	MOVLW  00DH
	CALL   sendcam
	MOVLW  00EH
	CALL   sendcam
	MOVLW  090H
	CALL   sendcam
	MOVLW  000H
	CALL   sendcam
	GOTO   wait
;---------------------------------------------------------------------------
; Status byte  
;---------------------------------------------------------------------------
tx6e                         ;classe non C1
	MOVLW   06EH
	GOTO    send_status
tx6d  MOVLW   06DH           ;instruzione non supportata
	GOTO    send_status  
tx67                         ;lunghezza zero
	MOVLW   067H
	GOTO    send_status
tx10
	MOVLW   010H           ;checksum errato 
	GOTO    send_status
tx90                         ;scrittura eseguita
	MOVLW   090H
send_status
	CALL    sendcam
		 
;---------------------------------------------------------------------------
; Attende istruzione  
;---------------------------------------------------------------------------
wait
	CLRF    checksum
	CALL    receive        ;riceve byte
	MOVWF   cla            ;cla
	CALL    receive         
	MOVWF   inst           ;inst
	CALL    receive 
	MOVWF   eeindirh       ;indirizzo alto eeprom
	CALL    receive
	MOVWF   eeindirl       ;indirizzo basso eeprom
	CALL    receive
	MOVWF   p3len          ;p3len
	MOVWF   msglen         ;msglen

	MOVF    cla,W
	XORLW   0xC1           ;verifica se classe C1
	skipz                  ;skip se zero
	GOTO    tx6e           ;classe non C1***
	MOVLW   001H
	XORWF   inst,W
	skipnz
	GOTO    inst01         ;inst 01 leggi da eeprom
	MOVLW   002H 
	XORWF   inst,W
	skipnz
	GOTO    inst02         ;inst 02 scrivi in eeprom 
	GOTO    tx6d           ;inst non supportata 

inst01
	MOVLW   002H
	SUBWF   msglen,W
	skipc
	GOTO    tx67          ;len < 2 
	MOVF    inst,W          
	CALL    sendcam       ;eco istruzione
	CALL    send_eep	    ;invio byte da eeprom
	MOVF    checksum,W    ;invio checksum
	CALL    sendcam
	GOTO    wait          ;attendo
inst02
	MOVLW   002H
	SUBWF   msglen,W
	skipc
	GOTO    tx67          ;len < 2 
	MOVF    inst,W          
	CALL    sendcam       ;eco istruzione
	MOVLW   rxbuffer      ;rxbuffer 
	MOVWF   FSR
inst02_2
	CALL    receive         ;riceve
	XORWF   checksum,F      ;esegue xor byte  byte
	MOVWF   INDIR           ;salva
	INCF    FSR,F
	DECFSZ  msglen,f
	GOTO    inst02_2        ;riceve tutti i byte
	MOVF    checksum,F      ;checksum deve essere zero
	skipz
	GOTO    tx10            ;checksum errato
	CALL    write_ee_0      ;indirizzo eeprom
	DECF    p3len,F         ;toglie checksum  
	MOVF    p3len,W         ;byte da scrivere
	MOVWF   bytecnt
	MOVLW   rxbuffer        ;da dove leggere
	MOVWF   FSR
	CALL    write_ee_y      ;scrive byte  
	GOTO    tx90            ;fine scrittura

;---------------------------------------------------------------------------
; sendcam
; trasmette il contenuto di W alla CAM
;---------------------------------------------------------------------------
sendcam
	BTFSS   PORTB,iocam     ;attende linea libera
	GOTO    sendcam 
	MOVWF   txrx            ;W ->txrx
	MOVLW   032H            ;ritardo normale
	BTFSC   check,0 
	MOVLW   00AH            ;ritardo se invio da eeprom
	CALL    delay_2
	MOVLW   0x7F            ;iocam output,altri input
	BSF     STATUS,RP0      ;pagina 1
	MOVWF   TRISB
	BCF     STATUS,RP0      ;pagina 0
	CLRF    txbuf           ;pulisce txbuf
	BCF     PORTB,07        ;porta basso rb7
	MOVLW   0x08        
	MOVWF   rxtxcnt         ;8 bit da trasmettere
sendcam_2  
	CALL    delay           ;ritardo
	RRF     txrx,f          ;bit nel carry
	RRF     txrx,W          ;carry in W bit + significativo
	ANDLW   0x80            ;bit 7 = carry ,resto tutto 0
	XORWF   txbuf,f         ;XOR di tutti i bit per parita'
	XORWF   PORTB,W         ;trasmette X,bit piu' significarivo,
	XORWF   PORTB,f         ;mettendo nella porta X0000000
	DECFSZ  rxtxcnt,f       ;-1 da trasmettere
	GOTO    sendcam_2
	CALL    delay           ;ritardo
	MOVF    txbuf,W         ;txbuf -> W
	XORWF   PORTB,W         ;trasmette parita'
	XORWF   PORTB,f
	CALL    delay           ;ritardo
	MOVLW   0xFF            ;setta porte come ingressi
	BSF     STATUS,RP0      ;pagina 1
	MOVWF   TRISB
	BCF     STATUS,RP0      ;pagina 0
	BTFSC   check,1         ;se invio da eeprom salto delay
	RETLW   000H
send_cam_end
	MOVLW   0x3E            ;ritardo
	GOTO    delay_2

;---------------------------------------------------------------------------
; receive
; riceve dalla CAM e memorizza in W
;---------------------------------------------------------------------------
receive
	BTFSC   PORTB,07        ;aspetta rb7 basso
	GOTO    receive
	MOVLW   0x2D            ;ritardo
	CALL    delay_2
	MOVLW   0x09
	MOVWF   rxtxcnt         ;9 bit da ricevere
receive_2       
	BCF     carrybit        ;pulisce carry
	BTFSC   PORTB,07    
	BSF     carrybit        ;carry a 1 se rb7 alto
	RRF     txrx,f          ;carry in txrx
	CALL    delay           ;delay
	DECFSZ  rxtxcnt,f       ;meno uno da ricevere
	GOTO    receive_2
	RLF     txrx,f          ;ruota a sinistra txrx di un bit 
	MOVLW   0x28
	CALL    delay_2         ;ritardo
	MOVF    txrx,W          ;byte ricevuto in W
	RETURN

;---------------------------------------------------------------------------
; delay
;---------------------------------------------------------------------------
delay           
	MOVLW   0x1A            ;W = 01AH
delay_2 
	MOVWF   rxtxdelay       ;setta ritardo
delay_3 
	DECFSZ  rxtxdelay,f     ;ritardo
	GOTO    delay_3          
	RETLW   000H            

;---------------------------------------------------------------------------
; send_eep      
; legge da eeprom e trasmette alla CAM
;---------------------------------------------------------------------------
send_eep
	DECF    msglen,F
	CALL    write_ee_0      ;indirizzo eprom da dove cominciare a leggere      
	BSF     check,0         ;TX diminuisce init delay
	BSF     check,1         ;TX elimina ritardo finale
send_eep_3       
	CALL    read_ee_next    ;leggo byte
	XORWF   checksum,F
	CALL    sendcam         ;lo invio
	DECFSZ  msglen,F        ;-1 da inviare
	GOTO    send_eep_3      ;next
send_eep_end
	BCF     check,0         ;fine invio da eeprom
	BCF     check,1        
	GOTO    send_cam_end  	

;---------------------------------------------------------------------------
; ROUTINES DI INTERFACCIAMENTO CON 24C32
;
; S           start bit
; 10100000    control byte scrivo
; 10100001    control byte leggo
; A           acknowledge bit
; N           no acknowledge bit
; H           indirizzo alto
; L           indirizzo basso
; D           DATO
; E           stop bit
;
; Lettura di un byte da un indirizzo specifico
; S 10100000 A HHHHHHHH A LLLLLLLL A S 10100001 A DDDDDDDD N E
;
; Letture del byte successivo a quello precedentemente letto
; S 10100001 A DDDDDDDD N E
;
; Scrittura in page mode
; Questo consente di impegnare la eeprom per circa 5ms e
; non 5ms per nr di byte da scrivere
; L'importante e' non superare il buffer del chip.
; No problem ... al massimo scrivo 8 byte
; S 10100000 A HHHHHHHH A LLLLLLLL A DDDDDDDD A .... DDDDDDDD A E
;
; Verifica di fine scrittura, tecnica "Data polling"
; S 10100000 A
; L'acknowledge basso ci indichera' che la eeprom e' libera
; Per evitare problemi dopo ogni richiesta viene inviato lo Stop bit,
; nel caso di eeprom libera si riparte dallo Start bit.
; 
;
; SDA = dati
; SCL = clock
;---------------------------------------------------------------------------

read_ee_next
	CALL    ee_startbit     ;altro start bit
	MOVLW   0A1H
	CALL    wr_ee_est       ;invio control byte 10100001 ,leggo
	CALL    rd_ee_est       ;leggo un byte
	CALL    ee_stopbit      ;stop bit
	MOVF    eepdata,W       ;byte letto -> W
	RETURN

write_ee_0                              
	CALL    ee_startbit     ;start bit
	MOVLW   0A0H
	CALL    wr_ee_est       ;invio control byte 10100000 ,scrivo
	BTFSC   check,5         ;eeprom impegnata in scrittura ?
	GOTO    write_ver_end   ;si,verifico che abbia terminato
	MOVF    eeindirh,W       
	CALL    wr_ee_est       ;invio indirizzo alto
	MOVF    eeindirl,W        
	GOTO    wr_ee_est       ;invio indirizzo basso

write_ver_end
	skipc                   ;eeprom ancora impegnata ?
	BCF     check,5         ;no, fine scrittura
	CALL    ee_stopbit      ;in ogni caso chiudi sessione
	GOTO    write_ee_0      ;... e riaccedi alla eeprom
	
write_ee_y                    ;scrive bytecnt byte in eeprom esterna
	BSF     check,5         ;segnalo scrittura in eeprom
write_ee_y2
	MOVF    INDIR,W         ;leggo byte
	CALL    wr_ee_est       ;scrivo byte
	INCF    FSR,F
	DECFSZ  bytecnt,F       ;skip if Zero
	GOTO    write_ee_y2     ;altro byte
	GOTO    ee_stopbit      ;stop bit

wr_ee_est
	MOVWF   eepdata         ;W -> eepdata,byte da scrivere
	MOVLW   0CFH            ;SDA e SCL uscite 
	BSF     STATUS,RP0      ;pagina 1
	MOVWF   TRISB           
	BCF     STATUS,RP0      ;pagina 0
	MOVLW     008H          ;trasmette 8 bit
	MOVWF   rxtxcnt
wr_loop
	RLF     eepdata,F       ;bit nel carry
	CALL    ee_bitwrite     ;trasmette un bit = carry 
	DECFSZ  rxtxcnt,F    
	GOTO    wr_loop         ;8 bit da trasmettere
	MOVLW   0DFH            ;SDA  ingresso
	BSF     STATUS,RP0      ;pagina 1
	MOVWF   TRISB
	BCF     STATUS,RP0      ;pagina 0
	BSF     PORTB,scl       ;clock alto
	GOTO    ee_bitread      ;2nop + riceve bit (ACK)

rd_ee_est
	MOVLW   0DFH            ;SDA ingresso
	BSF     STATUS,RP0      ;pagina 1
	MOVWF   TRISB
	BCF     STATUS,RP0      ;pagina 0
	MOVLW   008H            ;riceve 8 bit
	MOVWF   rxtxcnt
rd_loop
	BSF     PORTB,scl       ;clock alto
	CALL    ee_bitread      ;2nop + riceve bit
	RLF     eepdata,F       ;inserisce bit in eepdata
	DECFSZ  rxtxcnt,F
	GOTO    rd_loop         ;8 bit da ricevere
	MOVLW   0CFH            ;SDA come uscita
	BSF     STATUS,RP0      ;pagina 1
	MOVWF   TRISB
	BCF     STATUS,RP0      ;pagina 0
	BSF     carrybit        ;setta carry
                              ;ee_bitwrite, trasmette bit (NO ACK) 
ee_bitwrite
	skipc                   ;trasmette un bit , SDA = carry
	BCF     PORTB,sda        
	skipnc
	BSF     PORTB,sda
	BSF     PORTB,scl       ;clock alto
	nop
	nop
	GOTO    ee_scl_low      ;2nop + abbassa clock	

ee_bitread
	NOP                             
	NOP                             
	BSF     carrybit        ;carry = SDA
	BTFSS   PORTB,sda       
	BCF     carrybit
ee_scl_low
	BCF     PORTB,scl       ;clock basso
	RETURN

ee_startbit
	BSF     PORTB,sda       ;SDA alto
	MOVLW   0CFH            ;SDA e SCL uscite
	BSF     STATUS,RP0      ;pagina 1
	MOVWF   TRISB
	BCF     STATUS,RP0      ;pagina 0
	BSF     PORTB,scl       ;clock alto
	GOTO    ee_sda_low      ;2nop + abbassa SDA,condizione di start

ee_stopbit
	BCF     PORTB,sda       ;SDA basso
	MOVLW   0CFH            ;SDA e SCL uscite
	BSF     STATUS,RP0      ;pagina 1
	MOVWF   TRISB
	BCF     STATUS,RP0      ;pagina 0
	BSF     PORTB,scl       ;clock alto
	GOTO    ee_sda_high     ;2nop + alza SDA,condizione di STOP    

ee_sda_low
	BCF     PORTB,sda       ;abbassa SDA 
	GOTO    ee_scl_low      ;2nop + abbassa clock

ee_sda_high
	BSF     PORTB,sda       ;alza SDA
	GOTO    ee_scl_low      ;2nop + abbassa_clock



;---------------------------------------------------------------------------
; FUSES                                                     
;---------------------------------------------------------------------------
; Oscillator............................................ XT
; Code Protect.......................................... CP OFF
; WDT (WatchDog Timer).................................. OFF
; PWRT (Power Up Timer)................................. OFF
; BODEN (Brown Out Reset)............................... OFF
; LVP (Low Voltage Programming)......................... OFF
; CPD (Code Protection Data)............................ OFF
; WRT (Flash Programming Memory Write).................. OFF 
; DEBUGGER (BackGround Debugger Mode)................... OFF

	ORG     2007H

	DATA    3D39H

	END


